////////////////////////////////////////////////////////////////////////////////
//
//		Title		: EmbededNSB File
//
//		Copyright (C) 2006, NHN Co., Ltd. ALL RIGHTS RESERVED
//
//		Team		: Desktop Service Development
//
//		author		: hhd2002
//
//		created		: 23:11:2006   23:43
//  
////////////////////////////////////////////////////////////////////////////////
#pragma once

#include "NScrollBar.h"

/**
 * \group CommonUI
 * \brief {kr} Embeded NScrollBarŬ, Window ⺻ ũѹ Ӽ Ͽ Ӽ ´ ũѹٸ NScorllBar ׷ش. 
 * SubClassing NonClient MouseEvent ó, Paintó ؼ ߴ. {/kr}
 * \date 2006-12-28
 * \author hhd2002
 * \remark {kr}  {/kr}
 */
class NPCOMMONUI_API CEmbededNSB : public IScrollListener
{
public:
	CEmbededNSB();
	virtual ~CEmbededNSB(); 

	/**
	 * \brief 	{kr} Embeded NScrollBar ʱȭѴ. {/kr}
	 * \param hWndOwner {kr} ENSB Ǵ θ  ڵ {/kr}
	 * \param pNSBUI_Horz {kr}  ũѹ UI {/kr}
	 * \param pNSBUI_Vert {kr}  ũѹ UI {/kr}
	 * \param bHandle {kr} ڵ / {/kr}
	 */
	static BOOL		ENSB_Initialize(HWND hWndOwner, IScrollBarUI* pNSBUI_Horz, IScrollBarUI* pNSBUI_Vert, 
									BOOL bHandleHorz = FALSE, BOOL bHandleVert = FALSE);
	/**
	 * \brief 	{kr} ENSB ó. {/kr}
	 * \param hWndOwner {kr} ENSB Ǵ θ  ڵ {/kr}
	 */
	static BOOL		ENSB_Terminate(HWND hWndOwner);
	/**
	 * \brief 	{kr} SCROLLINFO ´. {/kr}
	 * \param hWnd {kr} ENSB Ǵ θ  ڵ {/kr}
	 * \param fnBar {kr} / ũѹ , SB_HORZ=, SB_VERT= {/kr}
	 * \param lpsi {kr} SCROLLINFO  {/kr}
	 */
	static BOOL		ENSB_GetScrollInfo(HWND hWnd, int fnBar, LPSCROLLINFO lpsi);
	/**
	 * \brief 	{kr} ũѹ ġ(=si.nPos) ´. {/kr}
	 * \param hWnd {kr} ENSB Ǵ θ  ڵ {/kr}
	 * \param code {kr} / ũѹ , SB_HORZ=, SB_VERT= {/kr}
	 */
	static int		ENSB_GetScrollPos(HWND hWnd, int code);
	/**
	 * \brief 	{kr} ũѹ  ´. {/kr}
	 * \param hWnd {kr} ENSB Ǵ θ  ڵ {/kr}
	 * \param code {kr} / ũѹ , SB_HORZ=, SB_VERT= {/kr}
	 * \param lpMinPos {kr} (=si.nMin) {/kr}
	 * \param lpMaxPos {kr} (=si.nMin) {/kr}
	 */
	static BOOL		ENSB_GetScrollRange(HWND hWnd, int code, LPINT lpMinPos, LPINT lpMaxPos);
	/**
	 * \brief 	{kr} SCROLLINFO ´. {/kr}
	 * \param hWnd {kr} ENSB Ǵ θ  ڵ {/kr}
	 * \param fnBar {kr} / ũѹ , SB_HORZ=, SB_VERT= {/kr}
	 * \param lpsi {kr} SCROLLINFO {/kr}
	 * \param fRedraw {kr} ٽñ׸ / {/kr}
	 */
	static int		ENSB_SetScrollInfo(HWND hWnd, int fnBar, LPSCROLLINFO lpsi, BOOL fRedraw = TRUE);
	/**
	 * \brief 	{kr} ũġ(=si.nPos) Ѵ. {/kr}
	 * \param hWnd {kr} ENSB Ǵ θ  ڵ {/kr}
	 * \param code {kr} / ũѹ , SB_HORZ=, SB_VERT= {/kr}
	 * \param nPos {kr} ũġ(=si.nPos) {/kr}
	 * \param fRedraw {kr} ٽñ׸ / {/kr}
	 */
	static int		ENSB_SetScrollPos(HWND hWnd, int code, int nPos, BOOL fRedraw = TRUE);
	/**
	 * \brief 	{kr} ũ  Ѵ. {/kr}
	 * \param hWnd {kr} ENSB Ǵ θ  ڵ {/kr}
	 * \param code {kr} / ũѹ , SB_HORZ=, SB_VERT= {/kr}
	 * \param nMinPos {kr} (=si.nMin) {/kr}
	 * \param nMaxPos {kr} (=si.nMin) {/kr}
	 * \param fRedraw {kr} ٽñ׸ / {/kr}
	 */
	static int		ENSB_SetScrollRange(HWND hWnd, int code, int nMinPos, int nMaxPos, BOOL fRedraw = TRUE);
	/**
	 * \brief 	{kr} ũѹ enable/disable {/kr}
	 * \param hWnd {kr} ENSB Ǵ θ  ڵ {/kr}
	 * \param code {kr} / ũѹ , SB_HORZ=, SB_VERT= {/kr}
	 * \param fShow {kr} show/unshow  {/kr}
	 */
	static BOOL		ENSB_Enable(HWND hWnd, int code, BOOL bEnable);
	
	/**
	 * \brief 	{kr} ڵ ũѹٸ Enable/Disable {/kr}
	 * \param hWnd {kr} window handle {/kr}
	 * \param code {kr} SB_xxx : Horizontal or Vertical ũѹ  {/kr}
	 * \param bEnable {kr} TRUE = Enable {/kr}
	 * \return 
	 */
	static BOOL		ENSB_EnableHandle(HWND hWnd, int code, BOOL bEnable);

	/**
	 * \brief 	{kr} Hũ ó ڵ鷯,  NScrollBar scrolllistener Ǿ ֱ  ⼭ scrollEvent 
	 * listen  ִ. {/kr}
	 * \param pScrollEvent {kr} ũ ̺Ʈ {/kr}
	 */
	virtual void	OnHScroll(CScrollEvent* pScrollEvent = NULL);
	/**
	* \brief 	{kr} Vũ ó ڵ鷯,  NScrollBar scrolllistener Ǿ ֱ  ⼭ scrollEvent 
	* listen  ִ. {/kr}
	* \param pScrollEvent {kr} ũ ̺Ʈ {/kr}
	*/
	virtual void	OnVScroll(CScrollEvent* pScrollEvent = NULL);

	LRESULT			OnNCHitTest(WPARAM wParam, LPARAM lParam);
	LRESULT			OnNCLBtnDn(WPARAM wParam, LPARAM lParam);
	LRESULT			OnLBtnDn(WPARAM wParam, LPARAM lParam);
	LRESULT			OnLBtnUp(WPARAM wParam, LPARAM lParam);
	LRESULT			OnMouseMove(WPARAM wParam, LPARAM lParam);
	LRESULT			OnNCMouseMove(WPARAM wParam, LPARAM lParam);
	LRESULT			OnNCLBtnDblClk(WPARAM wParam, LPARAM lParam);
	LRESULT			OnNCRBtnDn(WPARAM wParam, LPARAM lParam);
	LRESULT			OnNCRBtnDblClk(WPARAM wParam, LPARAM lParam);
	LRESULT			OnNCPaint(WPARAM wParam, LPARAM lParam);
	LRESULT			OnSize(WPARAM wParam, LPARAM lParam);
	
	CNScrollBar*	m_pNSBHorz; /* \breif {kr} Horizontal NScrollBar {/kr} */
	CNScrollBar*	m_pNSBVert;
	WNDPROC			m_pWndProcOld; /* \breif {kr} ý ޽ ν {/kr} */
	LRESULT			m_lrHitTest; /* \breif {kr}  mouse hittest {/kr} */
	CRect			m_rcNSBHorz; /* \breif {kr} Horizontal NScrollBar RECT {/kr} */
	CRect			m_rcNSBVert;
	HWND			m_hWndOwner; /* \breif {kr}  ũѹ parent window ڵ {/kr} */
	CRootContainer* m_pRootContainerHorz; /* \breif {kr} Horizontal NScrollBar ٴڿ  root container {/kr} */
	CRootContainer* m_pRootContainerVert;

protected:
private:
	static LRESULT CALLBACK		_ENSBProc(HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam); 
	/* \breif {kr} Embeded ScrollBar  Ű   ν {/kr} */

	#define ENSB_PROP	"ENSBProp"
};